
import GameLogic
import math
import mathutils

controller = GameLogic.getCurrentController()
owner = controller.owner
scene = GameLogic.getCurrentScene()
objList = scene.objects

# Object are adding during "life" frames, 0 is always
life = 2
empty = objList["Empty"]

# Get previous
stack = GameLogic.stack

## Get new data
X = (GameLogic.X/64.0)-2.0
Y = (GameLogic.Y/64.0)-2.0
Z = (GameLogic.Z/64.0)-2.0
mpYaw = (GameLogic.mpYaw-8000)/8000
mpPitch = (GameLogic.mpPitch-8000)/8000
mpRoll = (GameLogic.mpRoll-8000)/8000

ir = GameLogic.ir
if len(ir)>0:
    blob1X=ir[0][0]
    blob1Y=ir[0][1]
blob1X = (blob1X-512)/512
blob1Y = (blob1Y-384)/384

alpha = GameLogic.alpha/30
beta = GameLogic.beta/30
gamma = GameLogic.gamma/30
mpYawSlow = GameLogic.mpYawSlow
mpRollSlow = GameLogic.mpRollSlow
mpPitchSlow = GameLogic.mpPitchSlow

alpha_magenta = GameLogic.alpha_magenta/30
beta_magenta = GameLogic.beta_magenta/30
gamma_magenta = GameLogic.gamma_magenta/30

# With slow mode in motion plus
if mpYawSlow!=1:
    kYaw = 4.65
else:
    kYaw = 1.0
mpYaw=mpYaw*kYaw

if mpRollSlow!=1:
    kRoll = 4.65
else:
    kRoll = 1.0
mpPitch=mpPitch*kYaw

if mpPitchSlow !=1:
    kPitch = 4.65
else:
    kPitch = 1.0
mpRoll=mpRoll*kYaw


class histogram:
    def __init__(self, data, color):
        self.data = data
        self.color = color

    def stack(self, data, color): 
        nb_item = 30
        stack = GameLogic.stack[color]
        # Create list with nb items
        if len(stack) < nb_item:
            stack.append(data)
        # Add last acceleration and del the first in
        if len(stack) == nb_item:
            del stack[0]
            stack.append(data)
        GameLogic.stack[color] = stack

    def display_stack(self, data, color):
        '''j entre -1 et 1'''
        for j in range(len(stack[color])):
            cube = objList["Cube_"+ str(color)]
            empty.worldPosition = ( 1.05+(j*0.04)+2.0*(color%3) , 0, 3.4-0.63*int(color/3) )
            size = stack[color][j]
            empty.localScale = [ 1.0 , 1.0, 4*size]
            # Add OBWhite at name position during life frames
            scene.addObject(cube, empty, life)
        

# Display diagram
histogram(X,0).stack(X,0)
histogram(X,0).display_stack(X,0)

histogram(Y,1).stack(Y,1)
histogram(Y,1).display_stack(Y,1)

histogram(Z,2).stack(Z,2)
histogram(Z,2).display_stack(Z,2)

histogram(mpPitch,3).stack(mpPitch,3)
histogram(mpPitch,3).display_stack(mpPitch,3)

histogram(mpRoll,4).stack(mpRoll,4)
histogram(mpRoll,4).display_stack(mpRoll,4)

histogram(mpYaw,5).stack(mpYaw,5)
histogram(mpYaw,5).display_stack(mpYaw,5)

histogram(blob1X,6).stack(blob1X,6)
histogram(blob1X,6).display_stack(blob1X,6)

histogram(blob1Y,7).stack(blob1Y,7)
histogram(blob1Y,7).display_stack(blob1Y,7)

histogram(alpha,9).stack(alpha,9)
histogram(alpha,9).display_stack(alpha,9)

histogram(beta,10).stack(beta,10)
histogram(beta,10).display_stack(beta,10)

histogram(gamma,11).stack(gamma,11)
histogram(gamma,11).display_stack(gamma,11)

histogram(alpha_magenta,12).stack(alpha_magenta,12)
histogram(alpha_magenta,12).display_stack(alpha_magenta,12)

histogram(beta_magenta,13).stack(beta_magenta,13)
histogram(beta_magenta,13).display_stack(beta_magenta,13)

histogram(gamma_magenta,14).stack(gamma_magenta,14)
histogram(gamma_magenta,14).display_stack(gamma_magenta,14)
